Index: code/trunk/src/util/MultiType.h
===================================================================
--- code/trunk/src/util/MultiType.h	(revision 1784)
+++ code/trunk/src/util/MultiType.h	(revision 1791)
@@ -27,4 +27,37 @@
  */
 
+/**
+    @file MultiType.h
+    @brief Declaration of the MultiType and some helper constructs.
+
+    The MultiType can hold a value of one of the following types:
+     - all primitives
+     - all pointers
+     - string
+     - Vector2, Vector3, Vector4
+     - Quaternion
+     - ColourValue
+     - Radian, Degree
+
+    The MultiType has a "type" determined by the first assigned value, either through
+     - the constructor,
+     - the assignment operator= or
+     - setValue(value).
+    If you assign another value of another type, the MultiType keeps "it's" type and
+    converts the new value to this type.
+
+    If you want to change the type, there are three possibilities:
+     - convert<T>() set's the type to T and converts the currently assigned value
+     - setType<T>() set's the type to T and resets the value
+     - setValue<T>(value) assigns a new value and changes the type to T.
+
+    @example
+    MultiType a = 10;;         // a has now the type int and the value 10
+    a.setValue("3.14");        // a has still the type int and "3.14" gets converted, therefore the value is now 3
+    a.setValue<float>("3.14"); // a has now the type float and "3.14" gets converted to 3.14
+    a.convert<bool>();         // converts 3.14 to bool, which is true
+    a = false;                 // assigns false, this is equivalent to a.setValue(false)
+*/
+
 #ifndef _MultiType_H__
 #define _MultiType_H__
@@ -36,4 +69,7 @@
 #include "Math.h"
 
+/**
+    @brief Enum of all possible types of a MultiType.
+*/
 enum MT_Type
 {
@@ -64,4 +100,21 @@
 };
 
+/**
+    @brief The MultiType can hold a value of many possible types and convert them to other types.
+
+    The following types are supported by the MultiType:
+     - all primitves
+     - all pointers
+     - string
+     - Vector2, Vector3, Vector4
+     - Quaternion
+     - ColourValue
+     - Radian, Degree
+
+    The internal type of a MultiType is determined by the first assigned value, but can be
+    changed by using setType<T>(), convert<T>() or setValue<T>(value). If a value gets assigned
+    the normal way (operator=, setValue(value)), the value gets converted to the current internal
+    type of the MultiType.
+*/
 class _UtilExport MultiType
 {
@@ -69,4 +122,8 @@
     template <typename T> friend struct MT_Value;
 
+    /**
+        @brief MT_ValueBase is an almost pure virtual baseclass of MT_Value<T>, which holds the value of the MultiType.
+        This class is only used within the MultiType.
+    */
     struct _UtilExport MT_ValueBase
     {
@@ -78,4 +135,6 @@
         virtual void reset() = 0;
         virtual void assimilate(const MultiType& other) = 0;
+
+        /** @brief Returns the type of the current value. */
         const MT_Type& getType() const { return this->type_; }
 
@@ -130,41 +189,43 @@
         virtual void toString(std::ostream& outstream) const = 0;
 
-        MT_Type type_;
+        MT_Type type_; //! The type of the current value
     };
 
     public:
-        inline MultiType()                                  : value_(0) {}
-        inline MultiType(const char& value)                 : value_(0) { this->assignValue(value); }
-        inline MultiType(const unsigned char& value)        : value_(0) { this->assignValue(value); }
-        inline MultiType(const short& value)                : value_(0) { this->assignValue(value); }
-        inline MultiType(const unsigned short& value)       : value_(0) { this->assignValue(value); }
-        inline MultiType(const int& value)                  : value_(0) { this->assignValue(value); }
-        inline MultiType(const unsigned int& value)         : value_(0) { this->assignValue(value); }
-        inline MultiType(const long& value)                 : value_(0) { this->assignValue(value); }
-        inline MultiType(const unsigned long& value)        : value_(0) { this->assignValue(value); }
-        inline MultiType(const long long& value)            : value_(0) { this->assignValue(value); }
-        inline MultiType(const unsigned long long& value)   : value_(0) { this->assignValue(value); }
-        inline MultiType(const float& value)                : value_(0) { this->assignValue(value); }
-        inline MultiType(const double& value)               : value_(0) { this->assignValue(value); }
-        inline MultiType(const long double& value)          : value_(0) { this->assignValue(value); }
-        inline MultiType(const bool& value)                 : value_(0) { this->assignValue(value); }
-        inline MultiType(      void* const& value)          : value_(0) { this->assignValue(value); }
-        inline MultiType(const std::string& value)          : value_(0) { this->assignValue(value); }
-        inline MultiType(const orxonox::Vector2& value)     : value_(0) { this->assignValue(value); }
-        inline MultiType(const orxonox::Vector3& value)     : value_(0) { this->assignValue(value); }
-        inline MultiType(const orxonox::Vector4& value)     : value_(0) { this->assignValue(value); }
-        inline MultiType(const orxonox::ColourValue& value) : value_(0) { this->assignValue(value); }
-        inline MultiType(const orxonox::Quaternion& value)  : value_(0) { this->assignValue(value); }
-        inline MultiType(const orxonox::Radian& value)      : value_(0) { this->assignValue(value); }
-        inline MultiType(const orxonox::Degree& value)      : value_(0) { this->assignValue(value); }
-        inline MultiType(const char* value)                 : value_(0) { this->setValue(std::string(value)); }
-        inline MultiType(const MultiType& other)            : value_(0) { this->setValue(other); }
-        inline MultiType(MT_Type type)                      : value_(0) { this->setType(type); }
-
+        inline MultiType()                                  : value_(0) {}                                      /** @brief Default constructor: Assigns no value and no type. The type will be determined by the first assignment of a value. */
+        inline MultiType(const char& value)                 : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(const unsigned char& value)        : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(const short& value)                : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(const unsigned short& value)       : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(const int& value)                  : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(const unsigned int& value)         : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(const long& value)                 : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(const unsigned long& value)        : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(const long long& value)            : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(const unsigned long long& value)   : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(const float& value)                : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(const double& value)               : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(const long double& value)          : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(const bool& value)                 : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(      void* const& value)          : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(const std::string& value)          : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(const orxonox::Vector2& value)     : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(const orxonox::Vector3& value)     : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(const orxonox::Vector4& value)     : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(const orxonox::ColourValue& value) : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(const orxonox::Quaternion& value)  : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(const orxonox::Radian& value)      : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(const orxonox::Degree& value)      : value_(0) { this->assignValue(value); }           /** @brief Constructor: Assigns the given value and sets the type. */
+        inline MultiType(const char* value)                 : value_(0) { this->setValue(std::string(value)); } /** @brief Constructor: Converts the char array to a std::string, assigns the value and sets the type. */
+        inline MultiType(const MultiType& other)            : value_(0) { this->setValue(other); }              /** @brief Copyconstructor: Assigns value and type of the other MultiType. */
+        inline MultiType(MT_Type type)                      : value_(0) { this->setType(type); }                /** @brief Constructor: Sets the type, the next assignment will determine the value. */
+
+        /** @brief Destructor: Deletes the MT_Value. */
         inline ~MultiType() { if (this->value_) { delete this->value_; } }
 
-        template <typename V> inline const MultiType& operator=(const V& value)         { this->setValue(value); return (*this); }
-        inline                       const MultiType& operator=(const MultiType& other) { this->setValue(other); return (*this); }
-        inline                       const MultiType& operator=(MT_Type type)           { this->setType(type);   return (*this); }
+        template <typename V> inline const MultiType& operator=(const V& value)         { this->setValue(value); return (*this); } /** @brief Assigns a new value. The value will be converted to the current type of the MultiType. */
+        template <typename V> inline const MultiType& operator=(V* value)               { this->setValue(value); return (*this); } /** @brief Assigns a pointer. */
+        inline                       const MultiType& operator=(const MultiType& other) { this->setValue(other); return (*this); } /** @brief Assigns the value of the other MultiType and converts it to the current type of the MultiType. */
+        inline                       const MultiType& operator=(MT_Type type)           { this->setType(type);   return (*this); } /** @brief Resets the value and changes the type. */
 
         inline void                                   setValue(const char& value);
@@ -191,24 +252,33 @@
         inline void                                   setValue(const orxonox::Radian& value);
         inline void                                   setValue(const orxonox::Degree& value);
+        inline void                                   setValue(const char* value);
+        /** @brief Assigns a pointer. */
         template <typename V> inline void             setValue(V* value)               { if (this->value_) { this->value_->setValue((void*)value); } else { this->assignValue((void*)value); } }
+        /** @brief Assigns the value of the other MultiType and converts it to the current type. */
         void                                          setValue(const MultiType& other) { if (this->value_) { this->value_->assimilate(other); } else { if (other.value_) { this->value_ = other.value_->clone(); } } }
+        /** @brief Changes the type to T and assigns the new value (which might be of another type than T - it gets converted). */
         template <typename T, typename V> inline void setValue(const V& value)         { this->setType<T>(); this->setValue(value); }
-        inline void                                   setValue(const char* value);
-
+
+
+        /** @brief Copies the other MultiType by assigning value and type. */
         inline void                       copy(const MultiType& other)    { if (this == &other) { return; } if (this->value_) { delete this->value_; } this->value_ = (other.value_) ? other.value_->clone() : 0; }
 
-        template <typename T> inline void convert()                       { this->setValue<T>((T)(*this));  }
-        inline void                       convert(const MultiType& other) { this->convert(other.getType()); }
+        template <typename T> inline void convert()                       { this->setValue<T>((T)(*this));  } /** @brief Converts the current value to type T. */
+        inline void                       convert(const MultiType& other) { this->convert(other.getType()); } /** @brief Converts the current value to the type of the other MultiType. */
         void                              convert(MT_Type type);
 
+        /** @brief Resets the value to the defaultvalue of the current type. */
         inline void                       reset()                         { if (this->value_) { delete this->value_; this->value_ = 0; } }
 
-        template <typename T> inline void setType()                       { this->assignValue(T());             }
-        inline void                       setType(const MultiType& other) { this->setType(other.getType());     }
-        inline void                       setType(MT_Type type)           { this->reset(); this->convert(type); }
-
+        template <typename T> inline void setType()                       { this->assignValue(T());                            } /** @brief Resets the value and changes the internal type to T. */
+        inline void                       setType(const MultiType& other) { this->setType(other.getType());                    } /** @brief Resets the value and changes the internal type to the type of the other MultiType. */
+        inline void                       setType(MT_Type type)           { this->reset(); this->convert(type); this->reset(); } /** @brief Resets the value and changes the internal type to the given type. */
+
+        /** @brief Returns the current type. */
         inline MT_Type                    getType()                 const { return (this->value_) ? this->value_->type_ : MT_null; }
+        /** @brief Returns true if the current type equals the given type. */
         inline bool                       isType(MT_Type type)      const { return (this->value_) ? (this->value_->type_ == type) : (type == MT_null); }
-        template <typename T> inline bool isType()                  const { return false; }
+        /** @brief Returns true if the current type is T. */
+        template <typename T> inline bool isType()                  const { return false; } // Only works for specialized values - see below
         std::string                       getTypename()             const;
 
